% MATLAB CODE
% 
%   Contents file for MATLAB CODE and its subfolders.
%   
%   MATLAB CODE
%   main                     - Denoising and deblurring an image containing K blurred lines
%   make_doc                 - Generate a html documentation in folder doc/
%   
%   MATLAB CODE/MAIN FUNCTIONS
%   data_generation          - Generate K lines in a degraded image
%   minimization_Chambolle   - Minimization algorithm - relaxed Chambolle-Pock version
%   minimization_Condat      - Minimization algorithm - based on Condat's framework
%   prony                    - Recovering parameters of lines by the Prony method
%   resynthesis              - The denoised image xstar
%   
%   MATLAB CODE/TESTS
%   hough_lines_detection    - Hough transform applied to lines detection
%   noiseless                - Deblurred and estimate parameters of K blurred lines with high accuracy
%   radon_lines_detection    - Radon transform applied to lines detection
%   strong_blur              - Deblurred an image containing K strong blurred lines
%   strong_noise             - Denoising an image containing K blurred lines
%
%   MATLAB CODE/AUXILIARY FUNCTIONS
%   adjconv                  - Check the expression of the adjoint of a convolution
%   convmat                  - Check the equivalence between matrix product and operator convolution
%   Dirichlet_Kernel         - Dirichlet Kernel expression
%   dot2                     - Canonical inner product on complex vectors
%   dotF                     - Frobenius inner product
%   dotH                     - Inner product defined on space H=WxQ
%   dotQ                     - Inner product defined on space Q
%   dotQC                    - Inner production defined on space QC
%   dotW                     - Inner product defined on space W
%   dotWC                    - Inner product defined on space WC
%   dotWL                    - Inner product defined on space WL
%   FastPeakFind             - Analyze noisy 2D images and find peaks using local maxima
%   fixPSlinestyle           - Fix line styles in exported post script files
%   get_contents             - Get the contents of a specified directory
%   gradient                 - Of the operator A
%   normW                    - Norm defined on space W
%   opA                      - Operator A
%   opadjA                   - Adjoint of the operator A
%   opadjL1                  - Adjoint of the operator L1
%   opadjL2                  - Adjoint of the operator L2
%   opadjL3                  - Adjoint of the operator L3
%   opadjL4                  - Adjoint of the operator L4
%   opL1                     - Operator L1=L3+L4
%   opL2                     - Operator L2
%   opL3                     - Operator L3
%   opL4                     - Operator L4
%   proxsigmahconj           - Proximal operator of H*
%   proxsigmahNconj          - Proximal operator of H_N*
%   proxtaug                 - Proximal operator of G
%   proxtaugfour             - Proximal operator of G by FFT
%   proxtaugmat              - Proximal operator of G involving a big Kronecker product
%   proxtaugmat2             - Proximal operator of g involving M+1 smaller matrix products
%   test_adjoints            - Test adjoints
%   test_parametres_algo1    - Test which is the best parameters (tau,sigma) to perform minimization 1
%   test_parametres_algo2    - Test which is the best parameters (tau,sigma) to perform minimization 2
%   tightfig                 - Remove excess space around the figure
%   update_contents          - Create a Contents.m file including subdirectories
%    
%   This file was generated by update_contents.m .
%    
%   02-Mar-2016 17:46:52 .
