%% Check the expression of the adjoint of a convolution

% Adjoint of a 1-D convolution for the Hermitian inner product
S=5;
H=513;
M=256;
x=randn(1,H+2*S)+i*randn(1,H+2*S);
h=randn(1,2*S+1)+i*randn(1,2*S+1);
y=randn(1,length(x)-length(h)+1)+i*randn(1,length(x)-length(h)+1);
disp('<x*h,y>=<x,h*(-.)*y>');
dot2(conv(x,h,'valid'),y)
dot2(x,conv(y,conj(fliplr(h)),'full'))

% Adjoint of a 2-D convolution for the inner product defined on space W
wr=randn(H+2*S,M+1)+1i*randn(H+2*S,M+1);
wr(:,1)=real(wr(:,1)); % because its first column is real
Q=randn(H,M+1)+1i*randn(H,M+1);
Q(:,1)=real(Q(:,1));
h=real(h'); % column vector 
h
dotW(conv2(wr,h,'valid'),Q)
dotW(wr,conv2(Q,conj(flipud(h)),'full'))

% wr = [1 2 4 ; 1 2 3 ; 1 2 3 ; 1 2 3 ; 1 2 3];
% wr=randn(5,3);
% h = [2 1 3]';
% M=ones(3);
% WH=conv2(wr,h,'valid')
% MH=conv2(M,conj(flipud(h)),'full')
% WH.*M
% wr.*MH
% sum(sum(WH.*M))
% sum(sum(wr.*MH))
% x=wr(:,2)
% y=M(:,2)
% dot(conv(x,h,'valid'),y)
% dot(x,conv(y,conj(flipud(h)),'full'))



