%% Check the equivalence between matrix product and operator convolution

%%
% operators A and A* (matrix version)

% Random images
w=randn(Hs,M+1)+1i*randn(Hs,M+1);
w(:,1)=real(w(:,1));
yn=randn(H,M+1)+1i*randn(H,M+1);
yn(:,1)=real(yn(:,1));
Ydat=randn(Hs,M+1)+1i*randn(Hs,M+1);

% operator A
Amat=transpose(convmtx(h,H)); % size Hx(H+2S)
wopAmat=Amat*(w*Gfour);
wopAconv=opA(w);
disp(['wopAmat-wopAconv=',num2str(normW(wopAmat-wopAconv))])

% Operator A*
Atildemat=transpose(convmtx(hadj,Hs));
Astarmat=Atildemat(:,2*S+1:end-2*S); % size (H+2S)xH
wopadjAmat=Astarmat*yn*conj(Gfour);
wopadjAconv=opadjA(yn);
disp(['wopadjAmat-wopadjAconv=',num2str(normW(wopadjAmat-wopadjAconv))])

% Operator A* (second version)
Astarmat2=convmtx(flipud(hadj),H);
wopadjAmat2=Astarmat2*yn*conj(Gfour);
disp(['wopadjAmat2-wopadjAconv=',num2str(normW(wopadjAmat2-wopadjAconv))])

%%
% Aw = Amat*w*Gfour;
% A*y = Astarmat*y*Gfour*
% A*(Aw)=Astarmat*(Amat*w*Gfour)*Gfour*=PwQ
% P = Astarmat*Amat ; size (H+2S)x(H+2S)
% Q = Gfour*Gfour* = diag(|g0|^2,...,|gM|^2) ; size (M+1)x(M+1)
%
% X,Y : size (H+2S)x(M+1)
% Resolve tau*PXQ + X = Y
%
% More generally with X=(p,q) ; P=(p,p) ; Q=(q,q)

%%
% We check that A*A(w) is identical by convolution or matrices
P=Astarmat*Amat;
sp=size(P,1);
sq=size(Q,1);
Q=Gfour*conj(Gfour);
pwq=P*w*Q;
astaraw=opadjA(opA(w));
disp(['astaraw-pwq=',num2str(normW(astaraw-pwq))])
%normW(astaraw-pqwkron)

%%
% We resolve the system 
vecY=reshape(Ydat,[],1); % stack columns of Y in a big vector
PQkron=kron(transpose(Q),tau*P);
%pwqkron=PQkron*w;
opPQI=PQkron+eye(sp*sq);
vecX=inv(opPQI)*vecY;
Xsol=reshape(vecX,Hs,M+1);
Ycheck=tau*P*Xsol*Q+Xsol;
disp(['Ycheck-Ydat=',num2str(normW(Ycheck-Ydat))])

