function [wr_m qr_m] = opadjL1(Q)
%% Adjoint of the operator L1
% Input: matrix Q of size (Hs+1)^2
% Ouput: column vector wr_m and qr_m of size Hs
% Note: if m=0 wr_m has to be real
global Hs;
wr_m=zeros(Hs,1);
wr_m=(Q(1:Hs,Hs+1)+conj(Q(Hs+1,1:Hs)).')/2;

qr_m=zeros(Hs,1);
qr_m(1)=real(sum(diag(Q)))/2; % qr_m(0) doit tre rel
Q=Q(1:end-1,1:end-1);
for k=2:Hs
    qr_m(k)=(sum(diag(Q,k-1))+conj(sum(diag(Q,-k+1))))/2;
end
end

