function qr_m = opadjL3(Q)
%% Adjoint of the operator L3
% Input: matrix Q of size (Hs+1)^2
% Ouput: column vector wr_m and qr_m of size Hs
% Note: if m=0 wr_m has to be real
global Hs;

L3adj=zeros(Hs,1);
L3adj(1)=0.5*real(sum(diag(Q))); % qr_m(0) doit tre rel
for k=2:Hs
    for i=1:Hs-k+1
        L3adj(k)=L3adj(k)+0.5*(Q(i,k+i-1)+conj(Q(k+i-1,i)));
    end  
end

qr_m=L3adj;
end

