function Mpos = proxsigmahconj(M,sigma)
%% Proximal operator of H*
% Input: M of size N=M+1 or N=Hs
% Output: Mpos positive with same size

Mpos=M-sigma*proxhoversigma(M/sigma);

end


function Mpos=proxhoversigma(M)
	[V,D]=eig(M);
	Mpos=V*max(real(D),0)*V';
	Mpos=(Mpos+Mpos')/2; 	% stability
end
