%% Test adjoints
global Hs M Gfour h hadj;

%%
% Random images
%h=randn(1,2*S+1)+1i*randn(1,2*S+1);
wr=randn(H+2*S,M+1)+1i*randn(H+2*S,M+1);
wr(:,1)=real(wr(:,1)); % wr has its first column real
qr=randn(H+2*S,M+1)+1i*randn(H+2*S,M+1);
qr(1,:)=real(qr(1,:)); % qr has its first row real
X=cell(2);
X{1}=wr;
X{2}=qr;
%h=real(h'); 

%%
% Test A and A*
Q=randn(Hs,M+1)+1i*randn(Hs,M+1);
Q(:,1)=real(Q(:,1));
disp('<wr*Gfour,Q>_W=<wr,Q*conj(Gfour)>');
p1=dotW(wr*Gfour,Q);
p2=dotW(wr,Q*conj(Gfour));
if abs(p1-p2)<1e-5
    disp('--> check');
end
Q=randn(H,M+1)+1i*randn(H,M+1);
Q(:,1)=real(Q(:,1));
disp('<wr*h,Q>_W=<wr,hadj*Q>');
p1=dotW(conv2(wr,h,'valid'),Q);
p2=dotW(wr,conv2(Q,hadj,'full'));
if abs(p1-p2)<1e-5
    disp('--> check');
end
disp('<Awr,Q>_W=<wr,A*Q>');
p1=dotW(opA(wr),Q);
p2=dotW(wr,opadjA(Q));
if abs(p1-p2)<1e-5
    disp('--> check');
end

%%
% Test Lm and Lm*
m=3;
Q=randn(H+2*S+1)+1i*randn(H+2*S+1);
disp('<L3q,Q>_F=<q,L3*Q>_QC'); 
p1=dotF(opL3(qr(:,m)),Q);
p2=dotQC(qr(:,m),opadjL3(Q));
if abs(p1-p2)<1e-5
    disp('--> check');
end

disp('<L4x,Q>_F=<x,L4*Q>_WC'); 
p1=dotF(opL4(wr(:,m)),Q);
p2=dotWC(wr(:,m),opadjL4(Q));
if abs(p1-p2)<1e-5
    disp('--> check');
end

disp('<LmX,Q>_F=<X,Lm*Q>_H');
Lmstar=cell(2);
Lmstar{1}=zeros(Hs,M+1);
Lmstar{2}=zeros(Hs,M+1);
[Lmstar{1}(:,m),Lmstar{2}(:,m)]=opadjL1(Q);
p1=dotF(opL1(wr(:,m),qr(:,m)),Q);
p2=dotH(X,Lmstar);
if abs(p1-p2)<1e-5
    disp('--> check');
end

%%
% Test Ln2 and Ln2*
n2=3;
Q=randn(M+1)+1i*randn(M+1);
disp('<Ln2X,Q>_F=<X,Ln2*Q>_H');
Ln2star=cell(2);
Ln2star{1}=zeros(H+2*S,M+1);
Ln2star{2}=zeros(H+2*S,M+1);
Ln2star{1}(n2,:)=opadjL2(Q);
p1=dotF(opL2(wr(n2,:)),Q);
p2=dotH(X,Ln2star);
if abs(p1-p2)<1e-5
    disp('--> check');
end