%% Deblurred an image containing K strong blurred lines 
% * Generate $K$ lines with parameters $(\theta_k,\alpha_k,\eta_k)$, 
% blurred with a very large spread, in an image of size $W\times H$
% * Launch the minimization algorithm with parameters $(Nbiter,\rho,\tau,c)$
% * From the solution $\hat w_r^{\ast}$, estimate the lines by Prony

%% DATA GENERATION

W=65;               % image width (must be odd W=2M+1)
H=65;               % image height
K=3;                % number of lines
spread=8;           % std of the gaussian blur
noiselevel=0;     % level of noise
randomgen=0;        % boolean if lines are generated randomly of manually
rng(0);             % seed of random numbers generator
plotData=1;         % display images v, x and y
plotComp=0;         % display others comparaisons theo vs. emp

t_k=[pi/6 -pi/5 pi/16]; % array containing angles of lines
a_k=[255 255 255];      % array containing amplitude of lines
p_k=[10 0 -15];         % array containing offset of lines

data_generation;    % Generate the blurred image xstar 
                    % of these K lines with additional 
                    % noise y=xstar+randn(H,W)*noiselevel

%% MINIMIZATION ALGORITHM

Nbiter=2000;            % number of iterations
rho=1.9;                % weigth coefficient
tau=150000000;          % primal step (sigma is then computed from tau)
c=sum(a_k./cos(t_k));   % theoritical atomic norm of each line
plotError=1;            % compute and display error
displayIter=0;          % display the counter iteration
algo=2;                 % choose the minimization algorithm to use

minimization_Chambolle; % Find by minimization an approximation wr 
                        % of wstar which is the horizontal Fourier 
                        % transform of the deblurred image sstar

%% IMAGE RECONSTRUCTION AND LINES ESTIMATION

%%
% Reconstruct the denoised image xstar from wstar:

resynthesis;               

%%
% Estimate lines parameters and display it

cstar=sum(a_k./cos(t_k));  % theoritical atomic norm of each line
coef=cstar/c;              % factor between experimental and true amplitude
prony;              
